**********************************
* R&R Report Writer for Windows (Xbase Edition) temporary work file
* control routines.
*
* Example of usage.
*
* Source code (C) 1994, Nexgen Corporation
* Author:  John Koziol Internet: i486DX@aol.com
**********************************
*
* Requires:  R&R Report Writer (tm) (Xbase Edition) Version 2.
*            Microsoft FoxPro for Windows Version 2.5 or greater
*
* MakFormT and DelFormT routines are copyright (C) 1994 by Nexgen
* Corporation and are being distributed as shareware.  The may be
* freely copied or otherwise distributed.
*
* If you use these routines in your applications we would request
* that you register then with Nexgen with a $25 registration fee.
*
* To register, send $25.00 (Check or MO) to:
*
*              Nexgen Corporation
*              9132 SW 215th Terrace
*              Miami, Florida   33189
*
* If you have any suggestions on how these routines may be modified
* or added to that are really neat, we may waive the registration fee and
* we will credit you in the next release.
*
*
* R&R Report Writer (tm) Concentric Data Systems
* Microsoft FoxPro  (tm) Microsoft
*
**********************************

*:*****
* Example of calls to MakFormT and DelFormT functions.
*:*****

report_name = "FORMLTR"      && Report name in RP5 report library
report_id   = "FRL"          && Formctrl dbf form code for report
control_id  = "RCF"          && Formctrl dbf form code for R&R control file
drop_date   = DATE()-3       && Delete on or before date for old
                             && temp files
data_dir    = CURDIR()       && Path for report source dbf
image_dir   = CURDIR()       && Path for bitmaps or other images
rlib_dir    = CURDIR()       && Path for report library (.RP5 file)

*:****
*
* Make function calls to create new temp report and control file names and
* to delete any old temp report and control files.  Note that we are not
* storing the value returned from DelFormT.  The return value from that
* routine is the number of old temporary files deleted.
*
*:****


temp_rpt    = MakFormT(report_id)
temp_ctrl   = MakFormT(control_id)
            = DelFormT(report_id,drop_date)
            = DelFormT(control_id,drop_date)


*:****
* Use source dbf and copy it to file named as value of temp_rpt variable
*:****

USE rsource IN 0
SELECT rsource
COPY TO (temp_rpt)

*:****
* Use R&R control database and copy specific report record to file named as
* value of temp_ctrl variable.
*:****

USE rrwrunin IN 0
SELECT rrwrunin
LOCATE FOR ri_report = report_name
COPY NEXT 1 TO (temp_ctrl)

*:****
* Close original databases (no longer required)
*:****

USE IN rrwrunin
USE IN rsource

*:****
* Use new temporary R&R control file and change the master source file name
* to relect the temporary source file name as stored in variable temp_rpt.
*:****

USE (temp_ctrl) IN 0 ALIAS ctrltemp EXCLUSIVE

SELECT ctrltemp
REPLACE ri_master WITH temp_rpt
USE IN ctrltemp

*:****
* Close temporary control database.  If you don't do this, R&R may report
* a sharing violation.
*:****

!/N RRWRUN &temp_ctrl 1 /R&rlib_dir /D&data_dir /I&image_dir

