**********************************
* R&R Report Writer for Windows (Xbase Edition) temporary work file
* control routines.
*
* Source code for called procedure.
*
* Source code (C) 1994, Nexgen Corporation
* Author:  John Koziol Internet: i486DX@aol.com
**********************************
*
* Requires:  R&R Report Writer (tm) (Xbase Edition) Version 2.
*            Microsoft FoxPro for Windows Version 2.5 or greater
*
* MakFormT and DelFormT routines are copyright (C) 1994 by Nexgen
* Corporation and are being distributed as shareware.  The may be
* freely copied or otherwise distributed.
*
* If you use these routines in your applications we would request
* that you register then with Nexgen with a $25 registration fee.
*
* To register, send $25.00 (Check or MO) to:
*
*              Nexgen Corporation
*              9132 SW 215th Terrace
*              Miami, Florida   33189
*
* If you have any suggestions on how these routines may be modified
* or added to that are really neat, we may waive the registration fee and
* we will credit you in the next release.
*
*
* R&R Report Writer (tm) Concentric Data Systems
* Microsoft FoxPro  (tm) Microsoft
*
**********************************

*:*****
* Source code for MakFormT and DelFormT functions.
*:*****

****************
*
* MakFormT      :   Reserve and log a temporary file for forms using
*               :   The RRWRUN.EXE external driver for R&R Report Writer
*               :   for Windows (Xbase Edition).
*
* parms         :   mf_formid --- 3-char ID code for form
* returns       :   Report temporary file name to use.
*
****************

PROCEDURE makformt
PARAMETERS mf_formid

mf_area=SELECT()
USE formctrl IN 0 ORDER TAG formid
SELECT formctrl
SEEK mf_formid
IF !FOUND()
   DO WHILE .T.
      IF FLOCK()
         INSERT BLANK
         REPLACE formid WITH mf_formid,formno WITH "00001"
         UNLOCK
         EXIT
      ENDIF
   ENDDO
ENDIF

STORE ALLTRIM(mf_formid)+formctrl.formno TO mf_ret
STORE formctrl.formno                    TO mf_oldno

DO WHILE .T.
   IF FLOCK()
      INSERT BLANK
      REPLACE formid WITH mf_formid,;
              formno WITH RIGHT("00000"+LTRIM(STR(VAL(mf_oldno)+1)),5),;
              gendate WITH DATE()
      UNLOCK
      EXIT
   ENDIF
ENDDO
USE IN formctrl
SELECT (mf_area)
RETURN mf_ret


****************
*
* DelFormT      :   Delete old temporary files created with the
*                   MakFormT procedure above.
*
* parms         :   df_Formid,df_gendate
* returns       :   Number of deleted form files.
*
****************

PROCEDURE delformt
PARAMETERS df_formid,df_gendate
df_area=SELECT()
USE formctrl IN 0 ORDER TAG formdate
SELECT formctrl
SEEK df_formid+DTOS(df_gendate)
IF !FOUND() AND RECNO(0) # 0 
   GO RECNO(0)
   IF formctrl.formid # df_formid
      USE IN formctrl
      RETURN 0
   ENDIF
ENDIF
IF !FOUND() AND RECNO(0)=0
   USE IN formctrl
   RETURN 0
ENDIF
COUN TO df_allelig WHILE formid=df_formid AND gendate <= df_gendate
SEEK df_formid+DTOS(df_gendate)
IF !FOUND() 
   GO RECNO(0)
ENDIF
df_semi=IIF(df_allelig#0,df_allelig/2,0)
df_count=1
SCAN WHILE formid=df_formid AND gendate <= df_gendate
   df_killfile=ALLTRIM(formctrl.formid)+formctrl.formno
   IF FILE("&df_killfile.")
      DELETE FILE &df_fillfile
   ENDIF
ENDSCAN
SEEK df_formid+DTOS(df_gendate)
IF !FOUND()
   GO RECNO(0)
ENDIF
DO WHILE .T.
   IF FLOCK()
      DELETE WHILE formid=df_formid AND gendate <= df_gendate
      UNLOCK
      EXIT
   ENDIF
ENDDO
USE IN formctrl
SELECT (df_area)
RETURN df_allelig
